/* commonprefix.cc
 * This file belongs to Worker, a file manager for UN*X/X11.
 * Copyright (C) 2017 Ralf Hoffmann.
 * You can contact me at: ralf@boomerangsworld.de
 *   or http://www.boomerangsworld.de/worker
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "commonprefix.hh"
#include "aguix/util.h"

void CommonPrefix::updateCommonPrefix( const std::string &fullname )
{
    if ( m_first ) {
        AGUIXUtils::split_string( m_components,
                                  fullname,
                                  '/' );

        // the basename should always be separate so reduce the size by one

        if ( m_components.size() >= 1 ) {
            m_components.resize( m_components.size() - 1 );
        }

        m_first = false;
    } else {
        std::vector< std::string > temp_components;
            
        AGUIXUtils::split_string( temp_components,
                                  fullname,
                                  '/' );

        // the basename should always be separate so reduce the size by one

        if ( temp_components.size() >= 1 ) {
            temp_components.resize( temp_components.size() - 1 );
        }

        size_t p = 0;

        for ( ;; p++ ) {
            if ( p >= m_components.size() ) break;
            if ( p >= temp_components.size() ) break;

            if ( m_components[p] != temp_components[p] ) break;
        }

        // p is the first position of a different path component
        // therefore reduce size of vector
        m_components.resize( p );
    }
}

std::string CommonPrefix::getCommonPrefix()
{
    std::string res = "";

    for ( const auto &p : m_components ) {
        res += p;
        res += '/';
    }

    return res;
}
